searchData={"items":[{"type":"extras","title":"Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"# Raspberry Pi Zero 2 W and 3 A+ (64-bit)\n\n[![CircleCI](https://circleci.com/gh/nerves-project/nerves_system_rpi0_2.svg?style=svg)](https://circleci.com/gh/nerves-project/nerves_system_rpi0_2)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_system_rpi0_2.svg \"Hex version\")](https://hex.pm/packages/nerves_system_rpi0_2)\n\nThis is the base Nerves System configuration for the Raspberry Pi Zero 2 W with\nthe USB port running in gadget mode. It is similar to\n[nerves_system_rpi3a](https://github.com/nerves-project/nerves_system_rpi3a)\nexcept that it runs the ARM Cortex-A53 in 64-bit mode to support the [Erlang\nJIT](https://www.erlang.org/doc/apps/erts/beamasm).\n\n![Raspberry Pi Zero 2 W image](assets/images/rpi-zero2.jpg)\n  [Image credit](#rpi) \n\n| Feature              | Description                      |\n| -------------------- | -------------------------------- |\n| CPU                  | 1.4 GHz quad-core ARM Cortex-A53 |\n| Memory               | 512 MB DRAM                      |\n| Storage              | MicroSD                          |\n| Linux kernel         | 6.1 w/ Raspberry Pi patches      |\n| IEx terminal         | UART `ttyAMA0` Can be changed to HDMI |\n| GPIO, I2C, SPI       | Yes - [Elixir Circuits](https://github.com/elixir-circuits) |\n| ADC                  | No                               |\n| PWM                  | Yes, but no Elixir support       |\n| UART                 | 1 available - `ttyAMA0`          |\n| Display              | HDMI or 7\" RPi Touchscreen       |\n| Camera               | Official RPi Cameras (libcamera) |\n| Ethernet             | No                               |\n| WiFi                 | Yes                              |\n| Bluetooth            | [See Bluetooth](#bluetooth)      |\n| Audio                | HDMI out                         |","ref":"readme.html"},{"type":"extras","title":"Using - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"The most common way of using this Nerves System is create a project with `mix\nnerves.new` and to export `MIX_TARGET=rpi0_2`. See the [Getting started\nguide](https://hexdocs.pm/nerves/getting-started.html#creating-a-new-nerves-app)\nfor more information.\n\nIf you need custom modifications to this system for your device, clone this\nrepository and update as described in [Making custom\nsystems](https://hexdocs.pm/nerves/customizing-systems.html).","ref":"readme.html#using"},{"type":"extras","title":"Supported WiFi devices - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"The base image includes drivers for the onboard Raspberry Pi Zero 2 wifi module\n(`brcmfmac` driver).","ref":"readme.html#supported-wifi-devices"},{"type":"extras","title":"Camera - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"This system supports the official Raspberry Pi camera modules via\n[`libcamera`](https://libcamera.org/). The `libcamera` applications are included so it's\npossible to replicate many of the examples in the official [Raspberry Pi Camera\nDocumentation](https://www.raspberrypi.com/documentation/computers/camera_software.html).\n\nHere's an example commandline to run:\n\n```elixir\ncmd(\"libcamera-jpeg -n -v -o /data/test.jpeg\")\n```\n\nOn success, you'll get an image in `/data` that you can copy off with `sftp`.\n\nSince `libcamera` is being used instead of MMAL, the Elixir\n[picam](https://hex.pm/packages/picam) library won't work.","ref":"readme.html#camera"},{"type":"extras","title":"Bluetooth - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"[BlueHeronTransportUART](https://github.com/blue-heron/blue_heron_transport_uart)\nsupports Bluetooth on the Raspberry Pi Zero 2 W using `ttyS0`. The details are\nsimilar to the [RPi Zero W]\n(https://github.com/nerves-project/nerves_system_rpi0/issues/224#issuecomment-913799838).","ref":"readme.html#bluetooth"},{"type":"extras","title":"Audio - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"The Raspberry Pi has many options for audio output. This system supports the\nHDMI and stereo audio jack output. The Linux ALSA drivers are used for audio\noutput.\n\nThe general Raspberry Pi audio documentation mostly applies to Nerves. For\nexample, to force audio out the HDMI port, run:\n\n```elixir\ncmd(\"amixer cset numid=3 2\")\n```\n\nChange the last argument to `amixer` to `1` to output to the stereo output jack.","ref":"readme.html#audio"},{"type":"extras","title":"Gadget mode on the 3A+! - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"The Raspberry Pi 3 Model A+ is supported by the official\n[nerves_system_rpi3](https://github.com/nerves-project/nerves_system_rpi3), but\nthe USB port is configured to work as a host only. This Raspberry Pi can be\nconnected directly to your computer via a USB cable like the Raspberry Pi Zeros.\nTo do this, you'll need a USB A to USB A connector like\n[this](https://www.monoprice.com/product?p_id=5443) or\n[this](https://www.microcenter.com/product/431166/usb-a-to-a-high-speed-development-board-cable).","ref":"readme.html#gadget-mode-on-the-3a"},{"type":"extras","title":"Linux's preempt_rt patches - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"If you need better real-time performance from the Linux kernel, the `preempt_rt`\npatch set may help. Be aware that we do not test with the patches so this may\nnot work. To enable it, make a custom system using this one as a base and add\nthe following to the `nerves_defconfig`:\n\n```text\nBR2_LINUX_KERNEL_PATCH=\"http://cdn.kernel.org/pub/linux/kernel/projects/rt/4.19/patch-4.19.25-rt16.patch.xz\"\n```\n\nPlease verify the patch version since these instructions may be out-of-date.\n\nNext, update the Linux configuration to use it. Review the Nerves documentation\nfor running `make linux-menuconfig` and enable `PREEMPT_RT_FULL`. Alternately,\nmake the following change to the Linux configuration:\n\n```text\n-CONFIG_PREEMPT=y\n+CONFIG_PREEMPT_RT_FULL=y\n ```\n\nBuild the system and you should now have a preempt_rt kernel.","ref":"readme.html#linux-s-preempt_rt-patches"},{"type":"extras","title":"Provisioning devices - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"This system supports storing provisioning information in a small key-value store\noutside of any filesystem. Provisioning is an optional step and reasonable\ndefaults are provided if this is missing.\n\nProvisioning information can be queried using the Nerves.Runtime KV store's\n[`Nerves.Runtime.KV.get/1`](https://hexdocs.pm/nerves_runtime/Nerves.Runtime.KV.html#get/1)\nfunction.\n\nKeys used by this system are:\n\nKey                    | Example Value     | Description\n:--------------------- | :---------------- | :----------\n`nerves_serial_number` | `\"12345678\"`      | By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID.\n\nThe normal procedure would be to set these keys once in manufacturing or before\ndeployment and then leave them alone.\n\nFor example, to provision a serial number on a running device, run the following\nand reboot:\n\n```elixir\niex> cmd(\"fw_setenv nerves_serial_number 12345678\")\n```\n\nThis system supports setting the serial number offline. To do this, set the\n`NERVES_SERIAL_NUMBER` environment variable when burning the firmware. If you're\nprogramming MicroSD cards using `fwup`, the commandline is:\n\n```sh\nsudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw\n```\n\nSerial numbers are stored on the MicroSD card so if the MicroSD card is\nreplaced, the serial number will need to be reprogrammed. The numbers are stored\nin a U-boot environment block. This is a special region that is separate from\nthe application partition so reformatting the application partition will not\nlose the serial number or any other data stored in this block.\n\nAdditional key value pairs can be provisioned by overriding the default\nprovisioning.conf file location by setting the environment variable\n`NERVES_PROVISIONING=/path/to/provisioning.conf`. The default provisioning.conf\nwill set the `nerves_serial_number`, if you override the location to this file,\nyou will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices"},{"type":"extras","title":"Linux kernel and RPi firmware/userland - Raspberry Pi Zero 2 W and 3 A+ (64-bit)","doc":"There's a subtle coupling between the `nerves_system_br` version and the Linux\nkernel version used here. `nerves_system_br` provides the versions of\n`rpi-userland` and `rpi-firmware` that get installed. I prefer to match them to\nthe Linux kernel to avoid any issues. Unfortunately, none of these are tagged by\nthe Raspberry Pi Foundation so I either attempt to match what's in Raspbian or\ntake versions of the repositories that have similar commit times.\n\n[Image credit](#rpi): This image is from [raspberrypi.org](https://www.raspberrypi.com/products/raspberry-pi-zero-2-w/).","ref":"readme.html#linux-kernel-and-rpi-firmware-userland"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThis project does NOT follow semantic versioning. The version increases as\nfollows:\n\n1. Major version updates are breaking updates to the build infrastructure.\n   These should be very rare.\n2. Minor version updates are made for every major Buildroot release. This\n   may also include Erlang/OTP and Linux kernel updates. These are made four\n   times a year shortly after the Buildroot releases.\n3. Patch version updates are made for Buildroot minor releases, Erlang/OTP\n   releases, and Linux kernel updates. They're also made to fix bugs and add\n   features to the build infrastructure.","ref":"changelog.html"},{"type":"extras","title":"v1.28.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Changes\n  * Enable libdrm so that camera preview works\n\n* Updated dependencies\n  * [nerves_system_br v1.28.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.3)\n  * [Buildroot 2024.05.2](https://lore.kernel.org/buildroot/87zfpfh147.fsf@dell.be.48ers.dk/T/)\n  * [Erlang/OTP 27.0.1](https://erlang.org/download/OTP-27.0.1.README)","ref":"changelog.html#v1-28-1"},{"type":"extras","title":"v1.28.0 - Changelog","doc":"This is a major Erlang and Buildroot.\n\nPlease see the [nerves_system_br v1.28.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * Elixir 1.17 and Erlang/OTP 27 support\n  * Reduce copy/pasted definitions in the `fwup.conf` by extracting them to\n    `fwup_include/fwup-common.conf`. (No functional changes)\n\n* Fixes\n  * The serial numbers returned by `Nerves.Runtime.serial_number/0` now contain\n    the whole serial number. If you forked this system, check the\n    `boardid.config` and `erlinit.config` for the changes and to keep the\n    hostname the same.\n\n* Updated dependencies\n  * Linux 6.6.31 (Raspberry Pi stable_20240529 release)\n  * [nerves_system_br v1.28.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.1)\n  * [Buildroot 2024.05](https://lore.kernel.org/buildroot/87bk46tjk2.fsf@dell.be.48ers.dk/T/)\n  * [Erlang/OTP 27.0](https://erlang.org/download/OTP-27.0.README)","ref":"changelog.html#v1-28-0"},{"type":"extras","title":"v1.27.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Package updates\n  * [Erlang/OTP 26.2.5](https://erlang.org/download/OTP-26.2.5.README)\n  * [Buildroot 2024.02.1](https://lore.kernel.org/buildroot/87jzlp9u5e.fsf@48ers.dk/T/)","ref":"changelog.html#v1-27-1"},{"type":"extras","title":"v1.27.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.27.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.0)\nfor upgrade instructions if you've forked this system.\n\n* Changes\n  * The `libcamera` and `rpicam_apps` packages have been replaced with the\n    Raspberry Pi-forked versions for better compatibility. Please see\n    `nerves_system_br` release notes.\n  * Add back `CONFIG_RASPBERRYPI_GPIOMEM` to support the `dht` library.\n\n* Updated dependencies\n  * Linux 6.1.73 (Raspberry Pi 20240124 release)\n  * [nerves_system_br v1.27.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.27.0)\n  * [Buildroot 2024.02](https://lore.kernel.org/buildroot/87msrczp4z.fsf@48ers.dk/)\n  * [Erlang/OTP 26.2.3](https://erlang.org/download/OTP-26.2.3.README)","ref":"changelog.html#v1-27-0"},{"type":"extras","title":"v1.26.0 - Changelog","doc":"This is a major Buildroot update.\n\nPlease see the [nerves_system_br v1.26.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.0)\nfor upgrade instructions if you've forked this system.\n\n* New features\n  * Add the imx296 overlays for the Raspberry Pi Global Shutter Camera\n\n* Updated dependencies\n  * [Erlang/OTP 26.2.2](https://erlang.org/download/OTP-26.2.2.README)\n  * [nerves_system_br v1.26.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.26.1)\n  * [Buildroot 2023.11.1](https://lore.kernel.org/buildroot/87cyu2k2gu.fsf@48ers.dk/T/)","ref":"changelog.html#v1-26-0"},{"type":"extras","title":"v1.25.1 - Changelog","doc":"This is a security/bug fix update.\n\n*  Package updates\n  * [Erlang/OTP 26.2.1](https://erlang.org/download/OTP-26.2.1.README)\n  * [nerves_heart 2.3.0](https://github.com/nerves-project/nerves_heart/releases/tag/v2.3.0)","ref":"changelog.html#v1-25-1"},{"type":"extras","title":"v1.25.0 - Changelog","doc":"This is a major Buildroot and toolchain update that also adds support for using\nScenic without customizing the system.\n\nPlease see [nerves_system_br v1.25.0 release notes](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.25.0)\nfor upgrade instructions if you've forked this system.\n\n* New features\n  * Add libcairo for [Scenic](https://github.com/ScenicFramework/scenic) support\n\n* Updated dependencies\n  * [nerves_system_br v1.25.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.25.2)\n  * [Buildroot 2023.08.4](https://lore.kernel.org/buildroot/87o7f6t7fs.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.1.2](https://erlang.org/download/OTP-26.1.2.README)","ref":"changelog.html#v1-25-0"},{"type":"extras","title":"v1.24.1 - Changelog","doc":"This is a security/bug fix update.\n\n* Package updates\n  * [nerves_system_br v1.24.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.1)\n  * [Erlang/OTP 26.1.1](https://erlang.org/download/OTP-26.1.1.README)\n  * [Buildroot 2023.05.3](https://lore.kernel.org/buildroot/87h6ngup34.fsf@48ers.dk/T/)","ref":"changelog.html#v1-24-1"},{"type":"extras","title":"v1.24.0 - Changelog","doc":"This is a Buildroot version update that appears to mostly contain bug and\nsecurity fixes. It should be a low risk upgrade from v1.23.2.\n\n* Updated dependencies\n  * [nerves_system_br v1.24.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.24.0)\n  * [Buildroot 2023.05.2](https://lore.kernel.org/buildroot/87ledrkrpp.fsf@48ers.dk/T/), [2023.05.1](https://lore.kernel.org/buildroot/87351m8qm4.fsf@48ers.dk/T/), [2023.05](https://lore.kernel.org/buildroot/87r0qn2c77.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.1](https://erlang.org/download/OTP-26.1.README)","ref":"changelog.html#v1-24-0"},{"type":"extras","title":"v1.23.2 - Changelog","doc":"* Updated dependencies\n  * [nerves_system_br v1.23.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.3)","ref":"changelog.html#v1-23-2"},{"type":"extras","title":"v1.23.1 - Changelog","doc":"This is a bug and security fix update. It should be a low risk upgrade.\n\n* Fixes\n  * Fix CTRL+R over ssh\n\n* Updated dependencies\n  * [nerves_system_br v1.23.2](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.2)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87y1je6wva.fsf@48ers.dk/T/)","ref":"changelog.html#v1-23-1"},{"type":"extras","title":"v1.23.0 - Changelog","doc":"This is a major update that brings in Erlang/OTP 26, Buildroot 2023.02.2, Linux\n6.1, and Raspberry Pi firmware updates.\n\n* New features\n  * The Raspberry Pi cameras now work with libcamera. The libcamera apps are\n    included. See the [Raspberry Pi Camera docs](https://www.raspberrypi.com/documentation/computers/camera_software.html).\n  * CA certificates are included for OTP 26.\n\n* Changes\n  * The `start.elf` and `fixup.dat` files were renamed to `start4.elf` and\n    `fixup4.dat` to be more consistent with the RaspberryPi OS naming.\n\n* Updated dependencies\n  * [nerves_system_br v1.23.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.23.1)\n  * [Buildroot 2023.02.2](https://lore.kernel.org/buildroot/87wn03ifbl.fsf@48ers.dk/T/)\n  * [Erlang/OTP 26.0.2](https://erlang.org/download/OTP-26.0.2.README)\n  * Linux 6.1.21 (Raspberry Pi Linux tag 1.20230405)","ref":"changelog.html#v1-23-0"},{"type":"extras","title":"Previous releases - Changelog","doc":"This is a fork of [nerves_system_rpi3a](https://github.com/nerves-project/nerves_system_rpi3a).\nSee that project for previous history. The version numbers were kept for convenience.","ref":"changelog.html#previous-releases"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}